﻿using System;

namespace Calculator.Models
{
    /// <summary>
    /// Калькулятор, произодит все вычисления.
    /// </summary>
    public class Calculator
    {
        /// <summary>
        /// Разбирает правый и левый операнды и операцию, возвращает результат.
        /// </summary>
        /// <param name="left">Левый операнд</param>
        /// <param name="operation">Операция (+,-,*,/ или =)</param>
        /// <param name="right">Правый операнд</param>
        /// <returns></returns>
        public double Calculate(string left, string operation, string right)
        {
            double result = 0;
            double a;
            double b;
            switch (operation)
            {
                case "+":
                    a = double.Parse(left);
                    b = double.Parse(right);
                    result = a + b;
                    break;

                case "-":
                    a = double.Parse(left);
                    b = double.Parse(right);
                    result = a - b;
                    break;

                case "/":
                    a = double.Parse(left);
                    b = double.Parse(right);
                    if (b == 0) {
                        throw new DivideByZeroException(ViewRes.Home.DivideByZero);
                    }
                    result = a / b;
                    break;

                case "*":
                    a = double.Parse(left);
                    b = double.Parse(right);
                    result = a * b;
                    break;

            }

            return result;
        }
    }
}