﻿using System.Collections.Generic;
using System.Linq;

namespace Calculator.Repositories
{
    /// <summary>
    /// Реализация репозитория для калькулятора.
    /// </summary>
    public class CalculatorRepository : ICalculatorRepository
    {
        private readonly CalculatorDatabase _context = new CalculatorDatabase();
        
        public void Save(OperationHistoryItem item)
        {
            _context.OperationHistory.Add(item);
            _context.SaveChanges();
        }

        public IEnumerable<OperationHistoryItem> ViewAll()
        {
            return _context.OperationHistory.Select(o => o);
        }
    }
}