﻿using System.Collections.Generic;

namespace Calculator.Repositories
{
    /// <summary>
    /// Абстрактный репозиторий для доступа к базе данных.
    /// </summary>
    public interface IRepository<TEntity>
    {
        /// <summary>
        /// Сохраняет элемент в базу данных.
        /// </summary>
        /// <param name="entity"></param>
        void Save(TEntity entity);

        /// <summary>
        /// Возвращает список всех элементов, 
        /// без фильтрации и разбивки на страницы.
        /// </summary>
        /// <returns></returns>
        IEnumerable<TEntity> ViewAll();
    }
}