USE [master]
GO
IF EXISTS (SELECT name FROM sys.databases WHERE name = N'Calculator')
  DROP DATABASE [Calculator]
GO

CREATE DATABASE [Calculator] 
GO
USE [Calculator]
GO

IF (EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME = 'OperationHistory'))
BEGIN
    DROP TABLE OperationHistory
END
GO

CREATE TABLE [dbo].[OperationHistory](
  [Id] [int] IDENTITY(1,1)   NOT NULL,
  [RunAt] [datetime]         NOT NULL,
  [Operation] [varchar] (20) NOT NULL,
  [Result] [varchar] (20)    NOT NULL,
  CONSTRAINT [PK_Operations] PRIMARY KEY CLUSTERED ([Id] ASC)
)
GO
