﻿//   ...............................................................
//
//   Реализация js части калькулятора.
//   Отсюда правый, левый операнды и операция отсылаются 
//   в C#, результат отображается на дисплее.
//
//   ...............................................................

// создает калькулятор
function Calculator() 
{
    this.reset();
}

// обнуляет калькулятор
function reset() 
{   
    this.left = null;
    this.right = null;
    this.operation = null;
    this.display("0");
}

// показывает на калькуляторе значение
function display(value)
{
    if ($("span#inputbox").length == 1) {
        var inputbox = $("span#inputbox")[0];
        inputbox.innerHTML = value;
    }
}

// обрабатывает нажатие на (любую) кнопку
function processClick(button) 
{
    //var value = button.src.split('.')[0].split('/').pop();
    var value = button.name;
    if (value == "+" || value == "-" || value == "/" || value == "*" || value == "=") {
        this.processOperation(value);
    }
    else if (value == "ce") {
        this.reset();
    }
    else {
        this.processNumber(value);
    }    
}

// обрабатывает нажатие на +,-,*,/,=
function processOperation(operation) 
{
    if (this.left == null) {
        return;
    }

    if (this.right == null) {
        this.operation = operation;
        return;
    }

    var json = {
        left : this.left,
        right : this.right,
        operation : this.operation,
    };
    var calc = this;
    jQuery.post("/Home/Calculate", 
                json, 
                function(result) {
                    if (result.message != null) {
                        calc.reset();
                        calc.display(result.message);
                    }
                    else {
                        calc.left = result.value;
                        calc.right = null;
                        calc.operation = operation;
                        calc.display(result.value);
                    }
                }, 
                "json"
     );
}

// обрабатывает нажатие на число
function processNumber(number) 
{
    if (this.left == null) {
        this.left = number;
        this.display(this.left);
        return;
    }

    if (this.left != null && this.operation == null) {
        this.left += number;
        this.display(this.left);
        return;
    }

    if (this.operation != null && this.right == null) {
        this.right = number;
        this.display(this.right);
        return;
    }

    if (this.right != null && this.operation != null) {
        this.right += number;
        this.display(this.right);
        return;
    }
}

Calculator.prototype.reset = reset;
Calculator.prototype.display = display;
Calculator.prototype.processClick = processClick;
Calculator.prototype.processOperation = processOperation;
Calculator.prototype.processNumber = processNumber;
